**************************************************************************************
* Programa de Abertura da Porta Serial
* Linguagem - Clipper 5.3
* Descricao: Le porta Serial e grava em Dbf para exportao para o Harbour
* Copyright - Frank Lenon Rodrigues - Inicio 09/05/2002
**************************************************************************************

Procedure Main()
Parameters Comunica 
Local L := Row(), C := Col(), Area := Select()

If PCount() = 0
   Comunica := ''
Else
   Comunica :=  Alltrim( Comunica ) 
End If
Set Color To W+/B,B/BG
Clear
IniciaPorta()
CriaDbf()

@ 02,20 Say 'PROGRAMA DE RECEPCAO DE DADOS!!!'
@ 03,20 Say 'Flr Software!!!'

While LastKey() <> 301
   @ 11,20 Say +Time()
   @ L,C Say ''
      
   RecebeDados()
   @ 15,20 Say resposta
   Inkey(.5) 
   @ 11,40 Say '                         '
   @ L,C Say ''

EndDo

FechaPorta()

********************************************************************************
** Inicia Porta        
********************************************************************************
Procedure IniciaPorta()
Local Porta := .f.
Public f_Com := '', f_BaudeRate := 0 , f_databits := 0, f_parity:= 0 ,f_stopbit:= 0 , f_irq , f_Buff := 0
Public Buffer := Space(4000), Ack := 06, TmpBuf := '', DC4 := Chr( 20 )



If comunica = ''
  f_Com := "COM2"
  f_BaudeRate := 19200  
  f_databits := 7
  f_parity := 2
  f_stopbit := 1
  f_Buff := 8000

EndIf
//hb_init_port("COM2",57600,8,NOPARITY,ONESTOPBIT,4000);
 If Init_Port( f_Com, f_BaudeRate , f_databits , f_parity ,f_stopbit , f_Buff  )
   @ 12,20 Say "Porta Aberta!"
 Else
  @ 24,20 say 'Porta Fechada'
  Inkey( 0 )
  Quit
 EndIf



OutBufClr() // Limpa o Buffer de Sada

Clear

IF ISWORKING()
      @ 12,20 Say "Porta Conectada!"
ELSE

      @ 12,20 Say "Porta Desconectada!"

ENDIF

OutChr( chr(6) ) // Envia um Ack para a central

Return


********************************************************************************
* Fecha Porta
********************************************************************************
Procedure FechaPorta
** Fecha a porta
UnInt_Port()
Quit

Return Nil

********************************************************************************
** xFLock        ** Bloqueia o Arquivo...
********************************************************************************
Procedure xFLock
//Centra( 'Arquivo Bloqueado...')
Do While !FLock()
End Do
Return .T.

********************************************************************************
** xFree        ** Libera o Registro, o arquivo e Grava...
********************************************************************************
Procedure xFree
//Centra( 'Registro Liberado...')
DbCommit()
Unlock
Return .T.

**************************************************************************************
* Recebe Dados
********************************************************************************
Procedure recebedados()
      Local Dados := ''
      Public resposta := ''

      Rec := RecNo()
      Bytes := InbufSize()
      If Bytes > 0
         @ 11,40 Say 'Comunicando.'               // Comunicando...
         TmpBuf := TmpBuf + InChr( Bytes )                 // Le Buffer
         OutChr( @Ack )                        // Envia um Ack para a central

         While Len( TmpBuf) > 21
         Pos := At( DC4, TmpBuf )               // Cade o DC4
         Dados := Subs( TmpBuf, 1, Pos )        // Copiou o lixo...
         TmpBuf := Right( TmpBuf, Len(TmpBuf) - Pos )

         If Pos < 21   //Lixo
            @ 11,40 Say 'Aguarda'               // Descarta o lixo...
         Else
            If Len( Dados ) > 1 .And. At( '@', Dados ) = 0  .And. Subst( Dados, 15, 2 ) + SubStr( Dados, 19, 2 ) <> 'ri 1' // Ignora o HeartBeat e o evento de particao 1

               Select Monitor
               //   Append Blank // Salva em Disco
               DbAppend()
               xFlock()
               Replace Monitor->Evento With Dados, Monitor->Tamanho With Len( Dados ),;
                       Monitor->Data   WIth Date(), Monitor->Hora With Time()

               xFree()
               resposta = Dados
               @ 11,40 Say 'Gravou 1 '               // Salva os Dados...

            EndIf

         End If

         @ 11,40 Say 'Monitora Vs 2.0'               // Comunicando...

      End Do


      //  End If
   End If
   Skip -1


Return resposta


**************************************************************************************
* Cria Dbfs
********************************************************************************
Procedure  CriaDbf()

If !File('Monitor.Dbf')
 Select 200
 DbCreate( 'Monitor', { ;
   { 'Evento ', 'C', 21, 0 },;
   { 'Tamanho', 'N',  2, 0 },;
   { 'Data   ', 'D',  8, 0 },;
   { 'Hora   ', 'C', 10, 0 } } )
 Use
End If
Use Monitor  New shared

/*
If !File('MONITOR1.DBF')
 Select 200
 DbCreate( 'MONITOR1', { ;
   { 'Formato   ', 'C', 01, 0 },;
   { 'Linha     ', 'C', 01, 0 },;
   { 'Data      ', 'D', 10, 0 },;
   { 'CodCliente', 'C', 06, 0 },;
   { 'Hora      ', 'C', 10, 0 },;
   { 'NomeCli   ', 'C', 50, 0 },;
   { 'Pendencia ', 'C', 01, 0 },;
   { 'Imprime   ', 'C', 01, 0 },;
   { 'Filtro1   ', 'C', 01, 0 },;
   { 'Filtro2   ', 'C', 01, 0 },;
   { 'Filtro3   ', 'C', 01, 0 },;
   { 'Evento    ', 'C', 04, 0 },;
   { 'Operador  ', 'C', 20, 0 },;
   { 'EvenAlarm ', 'C', 80, 0 } } )
 Use
End If

Use Monitor1 New Shared
*/
